﻿using System;
using System.IO;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Windows.Media.SpeechSynthesis;

namespace Listener10
{
    public partial class MainWindow : Window
    {
        private SpeechSynthesizer _synthesizer = new SpeechSynthesizer();

        public MainWindow()
        {
            InitializeComponent();

            InitializeListboxVoiceChooser();

            Speak();
        }

        private async void Speak()
        {
            string text = "test is good";
            if (!string.IsNullOrEmpty(text))
            {
                try
                {
                    SpeechSynthesisStream synthesisStream = await _synthesizer.SynthesizeTextToStreamAsync(text);
                    // SpeechSynthesisStream synthesisStream = await synthesizer.SynthesizeSsmlToStreamAsync(Listener10.Properties.Resources.TTSText);

                    //Windows.Media.Playback.MediaPlayer mp = new Windows.Media.Playback.MediaPlayer();
                    //mp.SetStreamSource(synthesisStream);
                    //mp.Play();

                    System.Media.SoundPlayer sp = new System.Media.SoundPlayer();
                    sp.Stream = synthesisStream.AsStream();
                    sp.Play();
                }
                catch (Exception e)
                {
                    System.Diagnostics.Trace.WriteLine(e.ToString());
                }
            }
        }

        private void InitializeListboxVoiceChooser()
        {
            var voices = SpeechSynthesizer.AllVoices;

            VoiceInformation currentVoice = _synthesizer.Voice;

            foreach (VoiceInformation voice in voices.OrderBy(p => p.Language))
            {
                ListBoxItem item = new ListBoxItem();
                item.Content = voice.DisplayName + " (Language: " + voice.Language + ")";
                voiceList.Items.Add(item);

                if (currentVoice.Id == voice.Id)
                {
                    item.IsSelected = true;
                    voiceList.SelectedItem = item;
                }
            }
        }
    }
}
